//+------------------------------------------------------------------+
//|                              Copyright  2009, MethodTraders.com |
//|                                     http://www.methodtraders.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MethodTraders.com"
#property link      "http://www.methodtraders.com"

extern string
   EA_Settings             = "-------- General Settings";
extern bool
   ECNBroker               = true;
extern bool 
   UseTradeTime            = false;
extern string
   TradeTime_Start         = "7:00",
   TradeTime_End           = "21:00"; 
extern int
   MagicNumber             = 12345,
   Slippage                = 6,
   TakeProfit              = 0,
   StopLoss                = 0;
extern bool Martingale     = true;
extern double
   Lots                    = 0.01;
extern double MaxLots      = 10;   
extern bool
   TradeOnBarClose         = false;   
extern bool   
   CloseOnReverseSignal    = true,
   OneTradePerSignal       = false;   
extern string
   Indicator_Settings      = "-------- Indicator Settings";
extern int
   Sensitive               = 150,
   DeadZonePip             = 30,
   ExplosionPower          = 15,
   TrendPower              = 15;
extern bool
   UseADXFilter            = true;
extern int
   ADX_Period              = 5;
extern double 
   ADX_BuyLevel            = 35,
   ADX_SellLevel           = 35;
extern bool
   UseMAFilter               = true;   
extern int
   MA_Period               = 50,
   MA_Type                 = MODE_EMA;
      
int g,h;  
datetime TT;   
int MyDigits;
double MyPoint;
double TempLots = 0;
int first = 0;
//+------------------------------------------------------------------+
int init()
  {
//----
  if(Digits==5)MyDigits=4;
  else if(Digits==3)MyDigits=2;
  else MyDigits = Digits; 
  if (Point == 0.00001) MyPoint = 0.0001; //6 digits
  else if (Point == 0.001) MyPoint = 0.01; //3 digits (for Yen based pairs)
  else MyPoint = Point; //Normal
  TempLots = Lots; 
  TT = iTime(Symbol(),0,0);
  if(Digits==3||Digits==5)Slippage = Slippage*10;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int shift = 0;
   if(TradeOnBarClose)shift = 1;
   
 
   
   //----------INDICATOR INITIALZATION
   g =0;
   h = 0;
   int MAB = 0;
   int MAS = 0;
   if(UseMAFilter == true)
   {
      double MA = iMA(Symbol(),0,MA_Period,0,MA_Type,PRICE_CLOSE,shift);
      double CLOSE = iClose(Symbol(),0,shift);
      
      if(CLOSE>MA)MAB = 1;
      if(CLOSE<MA)MAS = 1;
   }
   if(UseMAFilter == false)
   {
      MAB = 1;
      MAS = 1;  
   }
   if (UseADXFilter == true) 
   {
      if (iADX(Symbol(),0,ADX_Period,0,1,shift)>ADX_BuyLevel)
         g = 1;
      if (iADX(Symbol(),0,ADX_Period,0,2,shift)>ADX_SellLevel)
         h = 1;
   }
   
   if (UseADXFilter == false)
   {
      g = 1;
      h = 1;
   }
   
    
   double Exp0=iCustom(Symbol(),0,"Waddah_Attar_Explosion",Sensitive,DeadZonePip,ExplosionPower,TrendPower,false,6,false,false,false,false,0,shift); 
   double Exp1=iCustom(Symbol(),0,"Waddah_Attar_Explosion",Sensitive,DeadZonePip,ExplosionPower,TrendPower,false,6,false,false,false,false,1,shift); 
   double Exp2=iCustom(Symbol(),0,"Waddah_Attar_Explosion",Sensitive,DeadZonePip,ExplosionPower,TrendPower,false,6,false,false,false,false,2,shift); 
   
   string Signal = "none";   
   
   if(Exp0>=Exp2 && g==1 && MAB ==1)Signal = "BUY";
   if(Exp1>=Exp2 && h==1 && MAS == 1)Signal = "SELL";
   //----------SIGNAL PROCESS

   int ticket = 0;
   //CLOSE TRADES
   if(CloseOnReverseSignal&&subTotalTrade()>0&&TT!=iTime(Symbol(),0,0)) 
   {
   
      if((Signal == "BUY")&&subTotalTypeOrders(OP_SELL)>0)
      {
         subCloseOrder();
      }
      
      if((Signal == "SELL")&&subTotalTypeOrders(OP_BUY)>0)
      {
         subCloseOrder();
      }
   }
 if(subTradingTime(UseTradeTime,TradeTime_Start, TradeTime_End)=="no")
   {
      Comment("None Trading Time");
      return(0);
   } 
   else Comment("Trading Time");
   //OPEN TRADES
   if(ECNBroker==false)
   {
      if(subTotalTrade()<1 && TT!=iTime(Symbol(),0,0))
      {
         //BUY
         if(Signal == "BUY"&& (OneTradePerSignal==false||subLastTradeType()==OP_SELL))
         {
            if (Martingale == true)
            {
               if (subLastTradePLTotal() < TakeProfit*MyPoint)
                  Lots = subLastLots()*2;
               else Lots = TempLots;
               if (subLastLots() >= MaxLots || subTotalTradeHist() < 1)Lots = TempLots;
            }
            ticket = subOpenOrder(OP_BUY, StopLoss, TakeProfit, Lots);
            if(ticket>0)TT=iTime(Symbol(),0,0);
         }
         //SELL
         if(Signal == "SELL"&& (OneTradePerSignal==false||subLastTradeType()==OP_BUY))
         {
            if (Martingale == true)
            {
               if (subLastTradePLTotal() < TakeProfit*MyPoint)
                  Lots = subLastLots()*2;
               else Lots = TempLots;
               if (subLastLots() >= MaxLots || subTotalTradeHist() < 1)Lots = TempLots;
            }
            ticket = subOpenOrder(OP_SELL, StopLoss, TakeProfit, Lots);
            if(ticket>0)TT=iTime(Symbol(),0,0);
         }
      
      }
   }
   if(ECNBroker==true)
   {
      if(subTotalTrade()<1 && TT!=iTime(Symbol(),0,0))
      {
         //BUY
         if(Signal == "BUY" && (OneTradePerSignal==false||subLastTradeType()==OP_SELL))
         {
            if (Martingale == true)
            {
               if (subLastTradePLTotal() < TakeProfit*MyPoint)
                  Lots = Lots*2;
               else Lots = TempLots;
               if (Lots > MaxLots || subTotalTradeHist() < 1)Lots = TempLots;
            }
            ticket = subOpenOrder(OP_BUY, 0, 0, Lots);
            if(ticket>0)
            {
               TT=iTime(Symbol(),0,0);
               subPlaceSLTP(ticket, MagicNumber,StopLoss,TakeProfit);
               subPlaceSLTP(ticket, MagicNumber,StopLoss,TakeProfit);
            }
         }
         //SELL
         if(Signal == "SELL" && (OneTradePerSignal==false||subLastTradeType()==OP_BUY))
         {
            if (Martingale == true)
            {
               if (subLastTradePLTotal() < TakeProfit*MyPoint)
                  Lots = Lots*2;
               else Lots = TempLots;
               if (Lots > MaxLots || subTotalTradeHist() < 1)Lots = TempLots;
            }
            ticket = subOpenOrder(OP_SELL, 0, 0, Lots);
            if(ticket>0)
            {
               TT=iTime(Symbol(),0,0);
               subPlaceSLTP(ticket, MagicNumber,StopLoss,TakeProfit);
               subPlaceSLTP(ticket, MagicNumber,StopLoss,TakeProfit);
            }
         }
      
      }
   }  
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
int subTotalTrade()
{
   int
      cnt, 
      total = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber) total++;
   }
   return(total);
}

// OPEN ORDERS
int subOpenOrder(int type, int stoploss, int takeprofit,double Lotz)
{
   string TicketComment = "Waddah EA";
   int NumberOfTries = 10;
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;

   if(stoploss!=0)
   {
      aStopLoss   = NormalizeDouble(Ask-stoploss*MyPoint,MyDigits);
      bStopLoss   = NormalizeDouble(Bid+stoploss*MyPoint,MyDigits);
   }
   
   if(takeprofit!=0)
   {
      aTakeProfit = NormalizeDouble(Ask+takeprofit*MyPoint,MyDigits);
      bTakeProfit = NormalizeDouble(Bid-takeprofit*MyPoint,MyDigits);
   }
   
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_BUY,Lotz,NormalizeDouble(Ask,Digits),Slippage,aStopLoss,aTakeProfit,TicketComment,MagicNumber,0,Green);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         RefreshRates();
         ticket=OrderSend(Symbol(),OP_SELL,Lotz,NormalizeDouble(Bid,Digits),Slippage,bStopLoss,bTakeProfit,TicketComment,MagicNumber,0,Red);
         err=GetLastError();
         if(err==0)
         { 
            if(ticket>0) break;
         }
         else
         {
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               if(ticket>0) break;
            }  
         }
      }   
   }  
   return(ticket);
}
//----------------------      
//CLOSES ALL OPEN TRADES
void subCloseOrder()
{
   int
         cnt, 
         total       = 0,
         ticket      = 0,
         err         = 0,
         c           = 0;

   int NumberOfTries = 10;
   total = OrdersTotal();
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
      {
         switch(OrderType())
         {
            case OP_BUY      :
               for(c=0;c<NumberOfTries;c++)
               {
                  RefreshRates();
                  ticket=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Violet);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }   
               continue;
               
            case OP_SELL     :
               for(c=0;c<NumberOfTries;c++)
               {
                  RefreshRates();
                  ticket=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Violet);
                  err=GetLastError();
                  if(err==0)
                  { 
                     if(ticket>0) break;
                  }
                  else
                  {
                     if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
                     {
                        Sleep(5000);
                        continue;
                     }
                     else //normal error
                     {
                        if(ticket>0) break;
                     }  
                  }
               }   
               continue;
         }
      }
   }      
}
// COUNTS THE TOTAL ORDERS DEPENDING ON TYPE
int subTotalTypeOrders(int Type)
{
   int
      cnt, 
      total = 0;

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()==Type&&OrderSymbol()==Symbol()&&
      OrderMagicNumber()==MagicNumber) total++;
   }
   return(total);
}

string subTradingTime(bool UseTradeTime,string TradeTime_Start, string TradeTime_End)
{
   int StartHour = TimeHour(StrToTime(TradeTime_Start));
   int StartMinute = TimeMinute(StrToTime(TradeTime_Start));
   
   int EndHour = TimeHour(StrToTime(TradeTime_End));
   int EndMinute = TimeMinute(StrToTime(TradeTime_End));
   
   string TradeTime = "no";

   if(UseTradeTime)
   {   
      if(StartHour<EndHour)
      {
         if(Hour()>=StartHour&&Hour()<=EndHour)
         {
            TradeTime = "yes";
            if(Hour()==StartHour&&Minute()<StartMinute)
            {
               TradeTime = "no";
            }
            if(Hour()==EndHour&&Minute()>EndMinute)
            {
               TradeTime = "no";
            }
         }
      }
      if(StartHour>EndHour)
      {
         if(Hour()>=StartHour||Hour()<=EndHour)
         {
            TradeTime = "yes";
            if(Hour()==StartHour&&Minute()<StartMinute)
            {
               TradeTime = "no";
            }
            if(Hour()==EndHour&&Minute()>EndMinute)
            {
               TradeTime = "no";
            }
         }
      }
   }
   if(!UseTradeTime)
   {   
      TradeTime = "not used";
   }
   return(TradeTime);      
}  



void subPlaceSLTP(int tick, int MagicNumber,int StopLoss,int TakeProfit)
{
    int total = OrdersTotal();
    for(int cnt=0;cnt<total;cnt++)
    {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

        if(OrderType()<=OP_SELL &&
             OrderSymbol()==Symbol() &&
             OrderMagicNumber()==MagicNumber && tick==OrderTicket())
      {
         //Print ("ModifyOrder "+OrderTicket()+"Magic "+OrderMagicNumber());
         if(OrderType()==OP_BUY)
         {
            if((NormalizeDouble(OrderTakeProfit(),Digits)!=NormalizeDouble(OrderOpenPrice()+(TakeProfit*Point),Digits)&&TakeProfit>0))
                  OrderModify(
                              OrderTicket(),
                              OrderOpenPrice(),
                              OrderStopLoss(),
                              NormalizeDouble(OrderOpenPrice()+(TakeProfit*Point),Digits),
                              0,
                              CLR_NONE);
                 
         }
         if(OrderType()==OP_SELL)
         {
            if(NormalizeDouble(OrderTakeProfit(),Digits)!=NormalizeDouble(OrderOpenPrice()-(TakeProfit*Point),Digits)&&TakeProfit>0)
                  OrderModify(
                              OrderTicket(),
                              OrderOpenPrice(),
                              OrderStopLoss(),
                              NormalizeDouble(OrderOpenPrice()-(TakeProfit*Point),Digits),
                              0,
                              CLR_NONE);

         }

      }
   }   
    total = OrdersTotal();
    for(cnt=0;cnt<total;cnt++)
    {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

        if(OrderType()<=OP_SELL &&
             OrderSymbol()==Symbol() &&
             OrderMagicNumber()==MagicNumber)
      {
         //Print ("ModifyOrder "+OrderTicket()+"Magic "+OrderMagicNumber());
                 if(OrderType()==OP_BUY)
         {
            if((NormalizeDouble(OrderStopLoss(),Digits)!=NormalizeDouble(OrderOpenPrice()-(StopLoss*Point),Digits)&&StopLoss>0))
                  OrderModify(
                              OrderTicket(),
                              OrderOpenPrice(),
                              NormalizeDouble(OrderOpenPrice()-(StopLoss*Point),Digits),
                              OrderTakeProfit(),
                              0,
                              CLR_NONE);
                 
         }
         if(OrderType()==OP_SELL)
         {
            if(NormalizeDouble(OrderStopLoss(),Digits)!=NormalizeDouble(OrderOpenPrice()+(StopLoss*Point),Digits)&&StopLoss>0)
                  OrderModify(
                              OrderTicket(),
                              OrderOpenPrice(),
                              NormalizeDouble(OrderOpenPrice()+(StopLoss*Point),Digits),
                              OrderTakeProfit(),
                              0,
                              CLR_NONE);

         }

      }
   }   
}
int subLastTradeType()
{
    int orders = OrdersHistoryTotal();
    int PL = 0;
    for(int i=orders-1;i>=0;i--)
    {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL||OrderMagicNumber()!=MagicNumber) continue;
         //----
            PL = OrderType();
            break;
    }

    return(PL);
}

double subLastTradePLTotal()
{
    int orders = OrdersHistoryTotal();
    double PL = 0;
    
    for(int i=orders-1;i>=0;i--)
    {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL||OrderMagicNumber()!=MagicNumber)continue;
         //----
         PL = PL+OrderProfit();
         if(OrderLots()==TempLots)break;
    }
    return(PL);
}
int subTotalTradeHist()
{
   int
      cnt, 
      total = 0;

   for(cnt=0;cnt<OrdersHistoryTotal();cnt++)
   {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL||OrderMagicNumber()!=MagicNumber)continue;
      total++;
   }
   return(total);
}
double subLastLots()
{
    int orders = OrdersHistoryTotal();
    double PL = 0;
    for(int i=orders-1;i>=0;i--)
    {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL||OrderMagicNumber()!=MagicNumber) continue;
         //----
            PL = OrderLots();
            if(PL>0)break;
    }

    return(PL);
}